// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// SendPhoneNumberConfirmationCodeRequest represents TL type `sendPhoneNumberConfirmationCode#8eae6cd9`.
type SendPhoneNumberConfirmationCodeRequest struct {
	// Hash value from the link
	Hash string
	// Phone number value from the link
	PhoneNumber string
	// Settings for the authentication of the user's phone number; pass null to use default
	// settings
	Settings PhoneNumberAuthenticationSettings
}

// SendPhoneNumberConfirmationCodeRequestTypeID is TL type id of SendPhoneNumberConfirmationCodeRequest.
const SendPhoneNumberConfirmationCodeRequestTypeID = 0x8eae6cd9

// Ensuring interfaces in compile-time for SendPhoneNumberConfirmationCodeRequest.
var (
	_ bin.Encoder     = &SendPhoneNumberConfirmationCodeRequest{}
	_ bin.Decoder     = &SendPhoneNumberConfirmationCodeRequest{}
	_ bin.BareEncoder = &SendPhoneNumberConfirmationCodeRequest{}
	_ bin.BareDecoder = &SendPhoneNumberConfirmationCodeRequest{}
)

func (s *SendPhoneNumberConfirmationCodeRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.Hash == "") {
		return false
	}
	if !(s.PhoneNumber == "") {
		return false
	}
	if !(s.Settings.Zero()) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *SendPhoneNumberConfirmationCodeRequest) String() string {
	if s == nil {
		return "SendPhoneNumberConfirmationCodeRequest(nil)"
	}
	type Alias SendPhoneNumberConfirmationCodeRequest
	return fmt.Sprintf("SendPhoneNumberConfirmationCodeRequest%+v", Alias(*s))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*SendPhoneNumberConfirmationCodeRequest) TypeID() uint32 {
	return SendPhoneNumberConfirmationCodeRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*SendPhoneNumberConfirmationCodeRequest) TypeName() string {
	return "sendPhoneNumberConfirmationCode"
}

// TypeInfo returns info about TL type.
func (s *SendPhoneNumberConfirmationCodeRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "sendPhoneNumberConfirmationCode",
		ID:   SendPhoneNumberConfirmationCodeRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Hash",
			SchemaName: "hash",
		},
		{
			Name:       "PhoneNumber",
			SchemaName: "phone_number",
		},
		{
			Name:       "Settings",
			SchemaName: "settings",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *SendPhoneNumberConfirmationCodeRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode sendPhoneNumberConfirmationCode#8eae6cd9 as nil")
	}
	b.PutID(SendPhoneNumberConfirmationCodeRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *SendPhoneNumberConfirmationCodeRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode sendPhoneNumberConfirmationCode#8eae6cd9 as nil")
	}
	b.PutString(s.Hash)
	b.PutString(s.PhoneNumber)
	if err := s.Settings.Encode(b); err != nil {
		return fmt.Errorf("unable to encode sendPhoneNumberConfirmationCode#8eae6cd9: field settings: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (s *SendPhoneNumberConfirmationCodeRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode sendPhoneNumberConfirmationCode#8eae6cd9 to nil")
	}
	if err := b.ConsumeID(SendPhoneNumberConfirmationCodeRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *SendPhoneNumberConfirmationCodeRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode sendPhoneNumberConfirmationCode#8eae6cd9 to nil")
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field hash: %w", err)
		}
		s.Hash = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field phone_number: %w", err)
		}
		s.PhoneNumber = value
	}
	{
		if err := s.Settings.Decode(b); err != nil {
			return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field settings: %w", err)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (s *SendPhoneNumberConfirmationCodeRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if s == nil {
		return fmt.Errorf("can't encode sendPhoneNumberConfirmationCode#8eae6cd9 as nil")
	}
	b.ObjStart()
	b.PutID("sendPhoneNumberConfirmationCode")
	b.Comma()
	b.FieldStart("hash")
	b.PutString(s.Hash)
	b.Comma()
	b.FieldStart("phone_number")
	b.PutString(s.PhoneNumber)
	b.Comma()
	b.FieldStart("settings")
	if err := s.Settings.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode sendPhoneNumberConfirmationCode#8eae6cd9: field settings: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (s *SendPhoneNumberConfirmationCodeRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if s == nil {
		return fmt.Errorf("can't decode sendPhoneNumberConfirmationCode#8eae6cd9 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("sendPhoneNumberConfirmationCode"); err != nil {
				return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: %w", err)
			}
		case "hash":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field hash: %w", err)
			}
			s.Hash = value
		case "phone_number":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field phone_number: %w", err)
			}
			s.PhoneNumber = value
		case "settings":
			if err := s.Settings.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode sendPhoneNumberConfirmationCode#8eae6cd9: field settings: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetHash returns value of Hash field.
func (s *SendPhoneNumberConfirmationCodeRequest) GetHash() (value string) {
	if s == nil {
		return
	}
	return s.Hash
}

// GetPhoneNumber returns value of PhoneNumber field.
func (s *SendPhoneNumberConfirmationCodeRequest) GetPhoneNumber() (value string) {
	if s == nil {
		return
	}
	return s.PhoneNumber
}

// GetSettings returns value of Settings field.
func (s *SendPhoneNumberConfirmationCodeRequest) GetSettings() (value PhoneNumberAuthenticationSettings) {
	if s == nil {
		return
	}
	return s.Settings
}

// SendPhoneNumberConfirmationCode invokes method sendPhoneNumberConfirmationCode#8eae6cd9 returning error if any.
func (c *Client) SendPhoneNumberConfirmationCode(ctx context.Context, request *SendPhoneNumberConfirmationCodeRequest) (*AuthenticationCodeInfo, error) {
	var result AuthenticationCodeInfo

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
