// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// SetLocationRequest represents TL type `setLocation#5993371`.
type SetLocationRequest struct {
	// The new location of the user
	Location Location
}

// SetLocationRequestTypeID is TL type id of SetLocationRequest.
const SetLocationRequestTypeID = 0x5993371

// Ensuring interfaces in compile-time for SetLocationRequest.
var (
	_ bin.Encoder     = &SetLocationRequest{}
	_ bin.Decoder     = &SetLocationRequest{}
	_ bin.BareEncoder = &SetLocationRequest{}
	_ bin.BareDecoder = &SetLocationRequest{}
)

func (s *SetLocationRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.Location.Zero()) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *SetLocationRequest) String() string {
	if s == nil {
		return "SetLocationRequest(nil)"
	}
	type Alias SetLocationRequest
	return fmt.Sprintf("SetLocationRequest%+v", Alias(*s))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*SetLocationRequest) TypeID() uint32 {
	return SetLocationRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*SetLocationRequest) TypeName() string {
	return "setLocation"
}

// TypeInfo returns info about TL type.
func (s *SetLocationRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "setLocation",
		ID:   SetLocationRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Location",
			SchemaName: "location",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *SetLocationRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode setLocation#5993371 as nil")
	}
	b.PutID(SetLocationRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *SetLocationRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode setLocation#5993371 as nil")
	}
	if err := s.Location.Encode(b); err != nil {
		return fmt.Errorf("unable to encode setLocation#5993371: field location: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (s *SetLocationRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode setLocation#5993371 to nil")
	}
	if err := b.ConsumeID(SetLocationRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode setLocation#5993371: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *SetLocationRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode setLocation#5993371 to nil")
	}
	{
		if err := s.Location.Decode(b); err != nil {
			return fmt.Errorf("unable to decode setLocation#5993371: field location: %w", err)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (s *SetLocationRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if s == nil {
		return fmt.Errorf("can't encode setLocation#5993371 as nil")
	}
	b.ObjStart()
	b.PutID("setLocation")
	b.Comma()
	b.FieldStart("location")
	if err := s.Location.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode setLocation#5993371: field location: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (s *SetLocationRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if s == nil {
		return fmt.Errorf("can't decode setLocation#5993371 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("setLocation"); err != nil {
				return fmt.Errorf("unable to decode setLocation#5993371: %w", err)
			}
		case "location":
			if err := s.Location.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode setLocation#5993371: field location: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetLocation returns value of Location field.
func (s *SetLocationRequest) GetLocation() (value Location) {
	if s == nil {
		return
	}
	return s.Location
}

// SetLocation invokes method setLocation#5993371 returning error if any.
func (c *Client) SetLocation(ctx context.Context, location Location) error {
	var ok Ok

	request := &SetLocationRequest{
		Location: location,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
