// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ThemeParameters represents TL type `themeParameters#8d6f03d4`.
type ThemeParameters struct {
	// A color of the background in the RGB24 format
	BackgroundColor int32
	// A color of text in the RGB24 format
	TextColor int32
	// A color of hints in the RGB24 format
	HintColor int32
	// A color of links in the RGB24 format
	LinkColor int32
	// A color of the buttons in the RGB24 format
	ButtonColor int32
	// A color of text on the buttons in the RGB24 format
	ButtonTextColor int32
}

// ThemeParametersTypeID is TL type id of ThemeParameters.
const ThemeParametersTypeID = 0x8d6f03d4

// Ensuring interfaces in compile-time for ThemeParameters.
var (
	_ bin.Encoder     = &ThemeParameters{}
	_ bin.Decoder     = &ThemeParameters{}
	_ bin.BareEncoder = &ThemeParameters{}
	_ bin.BareDecoder = &ThemeParameters{}
)

func (t *ThemeParameters) Zero() bool {
	if t == nil {
		return true
	}
	if !(t.BackgroundColor == 0) {
		return false
	}
	if !(t.TextColor == 0) {
		return false
	}
	if !(t.HintColor == 0) {
		return false
	}
	if !(t.LinkColor == 0) {
		return false
	}
	if !(t.ButtonColor == 0) {
		return false
	}
	if !(t.ButtonTextColor == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (t *ThemeParameters) String() string {
	if t == nil {
		return "ThemeParameters(nil)"
	}
	type Alias ThemeParameters
	return fmt.Sprintf("ThemeParameters%+v", Alias(*t))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ThemeParameters) TypeID() uint32 {
	return ThemeParametersTypeID
}

// TypeName returns name of type in TL schema.
func (*ThemeParameters) TypeName() string {
	return "themeParameters"
}

// TypeInfo returns info about TL type.
func (t *ThemeParameters) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "themeParameters",
		ID:   ThemeParametersTypeID,
	}
	if t == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "BackgroundColor",
			SchemaName: "background_color",
		},
		{
			Name:       "TextColor",
			SchemaName: "text_color",
		},
		{
			Name:       "HintColor",
			SchemaName: "hint_color",
		},
		{
			Name:       "LinkColor",
			SchemaName: "link_color",
		},
		{
			Name:       "ButtonColor",
			SchemaName: "button_color",
		},
		{
			Name:       "ButtonTextColor",
			SchemaName: "button_text_color",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (t *ThemeParameters) Encode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode themeParameters#8d6f03d4 as nil")
	}
	b.PutID(ThemeParametersTypeID)
	return t.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (t *ThemeParameters) EncodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode themeParameters#8d6f03d4 as nil")
	}
	b.PutInt32(t.BackgroundColor)
	b.PutInt32(t.TextColor)
	b.PutInt32(t.HintColor)
	b.PutInt32(t.LinkColor)
	b.PutInt32(t.ButtonColor)
	b.PutInt32(t.ButtonTextColor)
	return nil
}

// Decode implements bin.Decoder.
func (t *ThemeParameters) Decode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode themeParameters#8d6f03d4 to nil")
	}
	if err := b.ConsumeID(ThemeParametersTypeID); err != nil {
		return fmt.Errorf("unable to decode themeParameters#8d6f03d4: %w", err)
	}
	return t.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (t *ThemeParameters) DecodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode themeParameters#8d6f03d4 to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field background_color: %w", err)
		}
		t.BackgroundColor = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field text_color: %w", err)
		}
		t.TextColor = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field hint_color: %w", err)
		}
		t.HintColor = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field link_color: %w", err)
		}
		t.LinkColor = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field button_color: %w", err)
		}
		t.ButtonColor = value
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field button_text_color: %w", err)
		}
		t.ButtonTextColor = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (t *ThemeParameters) EncodeTDLibJSON(b tdjson.Encoder) error {
	if t == nil {
		return fmt.Errorf("can't encode themeParameters#8d6f03d4 as nil")
	}
	b.ObjStart()
	b.PutID("themeParameters")
	b.Comma()
	b.FieldStart("background_color")
	b.PutInt32(t.BackgroundColor)
	b.Comma()
	b.FieldStart("text_color")
	b.PutInt32(t.TextColor)
	b.Comma()
	b.FieldStart("hint_color")
	b.PutInt32(t.HintColor)
	b.Comma()
	b.FieldStart("link_color")
	b.PutInt32(t.LinkColor)
	b.Comma()
	b.FieldStart("button_color")
	b.PutInt32(t.ButtonColor)
	b.Comma()
	b.FieldStart("button_text_color")
	b.PutInt32(t.ButtonTextColor)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (t *ThemeParameters) DecodeTDLibJSON(b tdjson.Decoder) error {
	if t == nil {
		return fmt.Errorf("can't decode themeParameters#8d6f03d4 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("themeParameters"); err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: %w", err)
			}
		case "background_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field background_color: %w", err)
			}
			t.BackgroundColor = value
		case "text_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field text_color: %w", err)
			}
			t.TextColor = value
		case "hint_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field hint_color: %w", err)
			}
			t.HintColor = value
		case "link_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field link_color: %w", err)
			}
			t.LinkColor = value
		case "button_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field button_color: %w", err)
			}
			t.ButtonColor = value
		case "button_text_color":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode themeParameters#8d6f03d4: field button_text_color: %w", err)
			}
			t.ButtonTextColor = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetBackgroundColor returns value of BackgroundColor field.
func (t *ThemeParameters) GetBackgroundColor() (value int32) {
	if t == nil {
		return
	}
	return t.BackgroundColor
}

// GetTextColor returns value of TextColor field.
func (t *ThemeParameters) GetTextColor() (value int32) {
	if t == nil {
		return
	}
	return t.TextColor
}

// GetHintColor returns value of HintColor field.
func (t *ThemeParameters) GetHintColor() (value int32) {
	if t == nil {
		return
	}
	return t.HintColor
}

// GetLinkColor returns value of LinkColor field.
func (t *ThemeParameters) GetLinkColor() (value int32) {
	if t == nil {
		return
	}
	return t.LinkColor
}

// GetButtonColor returns value of ButtonColor field.
func (t *ThemeParameters) GetButtonColor() (value int32) {
	if t == nil {
		return
	}
	return t.ButtonColor
}

// GetButtonTextColor returns value of ButtonTextColor field.
func (t *ThemeParameters) GetButtonTextColor() (value int32) {
	if t == nil {
		return
	}
	return t.ButtonTextColor
}
